package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.system.domain.AiKnowledgeFragmentDo;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.AiKnowledgeFragmentBo;
import org.dromara.system.domain.vo.AiKnowledgeFragmentVo;
import org.dromara.system.mapper.AiKnowledgeFragmentMapper;
import org.dromara.system.service.IAiKnowledgeFragmentService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 知识片段Service业务层处理
 *
 * @author Lion Li
 * @date 2025-09-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AiKnowledgeFragmentServiceImpl implements IAiKnowledgeFragmentService {

    private final AiKnowledgeFragmentMapper baseMapper;

    /**
     * 查询知识片段
     *
     * @param id 主键
     * @return 知识片段
     */
    @Override
    public AiKnowledgeFragmentVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询知识片段列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 知识片段分页列表
     */
    @Override
    public TableDataInfo<AiKnowledgeFragmentVo> queryPageList(AiKnowledgeFragmentBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AiKnowledgeFragmentDo> lqw = buildQueryWrapper(bo);
        Page<AiKnowledgeFragmentVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的知识片段列表
     *
     * @param bo 查询条件
     * @return 知识片段列表
     */
    @Override
    public List<AiKnowledgeFragmentVo> queryList(AiKnowledgeFragmentBo bo) {
        LambdaQueryWrapper<AiKnowledgeFragmentDo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AiKnowledgeFragmentDo> buildQueryWrapper(AiKnowledgeFragmentBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AiKnowledgeFragmentDo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AiKnowledgeFragmentDo::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getKnowledgeCode()), AiKnowledgeFragmentDo::getKnowledgeCode, bo.getKnowledgeCode());
        lqw.eq(StringUtils.isNotBlank(bo.getDocCode()), AiKnowledgeFragmentDo::getDocCode, bo.getDocCode());
        lqw.eq(StringUtils.isNotBlank(bo.getFragmentCode()), AiKnowledgeFragmentDo::getFragmentCode, bo.getFragmentCode());
        lqw.eq(bo.getIdx() != null, AiKnowledgeFragmentDo::getIdx, bo.getIdx());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), AiKnowledgeFragmentDo::getContent, bo.getContent());
        return lqw;
    }

    /**
     * 新增知识片段
     *
     * @param bo 知识片段
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AiKnowledgeFragmentBo bo) {
        AiKnowledgeFragmentDo add = MapstructUtils.convert(bo, AiKnowledgeFragmentDo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改知识片段
     *
     * @param bo 知识片段
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(AiKnowledgeFragmentBo bo) {
        AiKnowledgeFragmentDo update = MapstructUtils.convert(bo, AiKnowledgeFragmentDo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AiKnowledgeFragmentDo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除知识片段信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
